/**
 * Created by jmoutard on 21/07/16.
 */

'use strict';

angular.module('adf.electre')
    .controller('dashboardCtrl', [
        "$scope", "$rootScope", "$stateParams", "storeService", "data", "defaultDashboard",
        function ($scope, $rootScope, $stateParams, storeService, data, defaultDashboard) {
            if (typeof data === "string") {
                switch (data) {
                    case "create":
                        var created_dashboard = JSON.parse(JSON.stringify(defaultDashboard));
                        created_dashboard.id = $stateParams.id;

                        storeService
                        /* Creating the dashboard. */
                            .add(created_dashboard.id, created_dashboard)
                            /* Broadcasting event from $rootScope to tell the navigationCtrl that the dashboard has been successfully created. */
                            .then(
                                function(){ /* SUCCESS */
                                    $rootScope.$broadcast("dashboardCreated", created_dashboard.id);
                                },
                                function () { /* ERROR */
                                    $rootScope.$broadcast("creatingError");
                                }
                            );
                        break;
                    case "remove":
                        storeService
                        /* Removing the dashboard. */
                            .remove($stateParams.id)
                            /* Broadcasting event from $rootScope to tell the navigationCtrl that the dashboard has been successfully removed. */
                            .then(
                                function () { /* SUCCESS */
                                    $rootScope.$broadcast("dashboardRemoved");
                                },
                                function () { /* ERROR */
                                    $rootScope.$broadcast("deletingError");
                                }
                            );
                        break;
                    case "import":
                        var imported_dashboard = JSON.parse($stateParams.dashboard);
                        imported_dashboard.id = imported_dashboard.id + 'imported';
                        imported_dashboard.title = imported_dashboard.title + " (imported)";

                        storeService
                        /* Creating the dashboard. */
                            .add(imported_dashboard.id, imported_dashboard)
                            /* Broadcasting event from $rootScope to tell the navigationCtrl that the dashboard has been successfully created. */
                            .then(
                                function(){ /* SUCCESS */
                                    $rootScope.$broadcast("dashboardCreated", imported_dashboard.id);
                                },
                                function () { /* ERROR */
                                    $rootScope.$broadcast("creatingError");
                                }
                            );
                        break;
                    case "duplicate":
                        var duplicated_dashboard = JSON.parse($stateParams.dashboard);
                        duplicated_dashboard.id = duplicated_dashboard.id + "duplicata";
                        duplicated_dashboard.title = duplicated_dashboard.title + " (duplicata)";

                        storeService
                        /* Creating the dashboard. */
                            .add(duplicated_dashboard.id, duplicated_dashboard)
                            /* Broadcasting event from $rootScope to tell the navigationCtrl that the dashboard has been successfully created. */
                            .then(
                                function(){ /* SUCCESS */
                                    $rootScope.$broadcast("dashboardCreated", duplicated_dashboard.id);
                                },
                                function () { /* ERROR */
                                    $rootScope.$broadcast("creatingError");
                                });
                        break;
                }
            } else {
                this.name = $stateParams.id || 0;
                this.model = data || undefined;

                if (this.model) {
                    if (this.model.collapsible !== false && this.model.collapsible !== true) this.model.collapsible = true;
                    if (this.model.maximizable !== false && this.model.maximizable !== true) this.model.maximizable = true;
                }
                
                $scope.name = this.name;
                $scope.model = this.model;
                $scope.collapsible = $scope.model.collapsible;
                $scope.maximizable = $scope.model.maximizable;
                $scope.safeMode = true;

                $scope.$on("adfIsEditMode", function () { $scope.safeMode = false; });
                $scope.$on("adfDashboardEditsCancelled", function () { $scope.safeMode = true; });

                $scope.$on('adfDashboardChanged', function(event, name, model) {
                    $scope.safeMode = true;
                    storeService.add(name, model).then(function () {
                        $scope.dashboardIsSaved = true;
                        $rootScope.$broadcast('navChanged');
                    });
                });
            }
        }
    ]);